'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactClass = require('react-class');

var _reactClass2 = _interopRequireDefault(_reactClass);

var _Row = require('./Row');

var _Row2 = _interopRequireDefault(_Row);

var _shallowequal = require('shallowequal');

var _shallowequal2 = _interopRequireDefault(_shallowequal);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ColumnGroupInnerWrapper = function (_Component) {
  _inherits(ColumnGroupInnerWrapper, _Component);

  function ColumnGroupInnerWrapper() {
    _classCallCheck(this, ColumnGroupInnerWrapper);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(ColumnGroupInnerWrapper).apply(this, arguments));
  }

  _createClass(ColumnGroupInnerWrapper, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      return !(0, _shallowequal2.default)(nextProps, this.props);
    }
  }, {
    key: 'render',
    value: function render() {
      var props = this.props;
      var data = props.data;
      var from = props.from;
      var to = props.to;
      var rowHeight = props.rowHeight;
      var globalProps = props.globalProps;
      var onRowMouseEnter = props.onRowMouseEnter;
      var onRowMouseLeave = props.onRowMouseLeave;
      var onRowClick = props.onRowClick;
      var renderRow = props.renderRow;
      var cellFactory = props.cellFactory;
      var rowStyle = props.rowStyle;
      var overRowId = props.overRowId;
      var
      // selected can be an object or an index
      selected = props.selected;
      var isMultiselect = props.isMultiselect;
      var hasSelection = props.hasSelection;
      var activeIndex = props.activeIndex;
      var passedProps = props.rowProps;
      var zebraRows = props.zebraRows;
      var bufferValid = props.bufferValid;
      var isScrolling = props.isScrolling;
      var isPlaceholderActive = props.isPlaceholderActive;
      var renderRowPlaceholder = props.renderRowPlaceholder;
      var columns = props.columns;
      var minWidth = props.minWidth;
      var rowKey = props.rowKey;


      var rows = data.slice(from, to).map(function (rowData, index, dataSlice) {
        var id = rowData[globalProps.idProperty];
        var over = overRowId === id;
        var realIndex = index + from;
        var even = !!(realIndex % 2);
        var active = activeIndex === realIndex;

        var keyIndex = rowKey === 'realIndex' ? realIndex : index;
        var key = 'row-' + keyIndex;

        var isSelected = hasSelection && (isMultiselect ? selected.hasOwnProperty(id) : // TODO: use hasOwn, with curry
        selected == id // to allow type conversion, so 5 == '5'
        );

        var rowProps = {
          id: id,
          columns: columns,
          minWidth: minWidth,
          active: active,
          key: key,
          over: over,
          renderRow: renderRow,
          cellFactory: cellFactory,
          rowStyle: rowStyle,
          realIndex: realIndex, // is used rowSelect, for a correct selection (onClick)
          rowHeight: rowHeight,
          passedProps: passedProps,
          bufferValid: bufferValid,
          isScrolling: isScrolling,
          isPlaceholderActive: isPlaceholderActive,
          renderRowPlaceholder: renderRowPlaceholder,
          selected: isSelected, // row uses selected as a bool, a state
          data: rowData,
          onMouseEnter: onRowMouseEnter,
          onMouseLeave: onRowMouseLeave,
          onClick: onRowClick,

          even: false,
          odd: false
        };

        if (zebraRows) {
          rowProps.even = even;
          rowProps.odd = !even;
        }

        var row = void 0;
        if (props.rowFactory) {
          row = props.rowFactory(rowProps);
        }

        if (row === undefined) {
          row = _react2.default.createElement(_Row2.default, rowProps);
        }

        return row;
      });

      return _react2.default.createElement(
        'div',
        null,
        rows
      );
    }
  }]);

  return ColumnGroupInnerWrapper;
}(_reactClass2.default);

exports.default = ColumnGroupInnerWrapper;


ColumnGroupInnerWrapper.defaultProps = {
  rowKey: 'realIndex'
};

ColumnGroupInnerWrapper.propTypes = {
  rowKey: _react.PropTypes.oneOf(['realIndex', 'renderIndex'])
};